import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class nC {
	class Point implements Comparable<Point> {
		int t, w;

		@Override
		public int compareTo(Point o) {
			if (t != o.t) {
				return t - o.t;
			}
			return w - o.w;

		}

	}

	class Value {
		int v = 0;
		boolean bol = false;
	}

	public void run() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		pw = new PrintWriter(System.out);

		int n = nextInt();
		int T = nextInt();
		Point[] pp = new Point[n + 1];
		pp[0] = new Point();
		pp[0].t = -1;
		pp[0].w = 0;
		for (int i = 1; i <= n; i++) {
			pp[i] = new Point();
			pp[i].t = nextInt();
			pp[i].w = nextInt();
		}
		Arrays.sort(pp);
		int tmp = pp[1].t;
		Value[][] arr = new Value[n + 1][T + 1];
		for (int i = 0; i <= T; i++) {
			arr[0][i] = new Value();
		}
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j <= T; j++) {
				arr[i][j] = new Value();
				if (pp[i].t > j) {
					arr[i][j].v = arr[i - 1][j].v;
					continue;
				}
				if (pp[i].t == j) {
					if (arr[i - 1][j].bol && j > 1) {
						arr[i][j].v = Math.min(pp[i].w, arr[i - 1][j].v);
					} else {
						arr[i][j].v = pp[i].w;
					}
					arr[i][j].bol = true;
				} else {
					if (arr[i][j - pp[i].t].bol) {
						arr[i][j].v = arr[i][j - pp[i].t].v + pp[i].w;
					} else {
						arr[i][j].v = Math.min(arr[i][j - 1].v, arr[i - 1][j - pp[i].t].v + pp[i].w);
					}
				}
			}
		}
		pw.print(arr[n][T].v);
		pw.close();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter pw;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new nC().run();
	}

}