
#include <bits/stdc++.h>

using namespace std;

#ifdef ONPC
	mt19937 rnd(228);
#else
	mt19937 rnd(time(0));
#endif

const int N = 1e6 + 7;
vector <int> bad[N], good[N];
vector <int> g[N], rg[N];
vector <int> chelik[N];

void add_edge(int a, int b)
{
	g[a].push_back(b);
	rg[b].push_back(a);
}

bool u[N];
int comp[N];
vector <int> t;

void dfs(int v)
{
	u[v] = true;
	for (int to : g[v])
	{
		if (!u[to])
		{
			dfs(to);
		}
	}
	t.push_back(v);
}

int ind = 0;

void zhfs(int v)
{
	u[v] = true;
	comp[v] = ind;
	for (int to : rg[v])
	{
		if (!u[to])
		{
			zhfs(to);
		}
	}
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	/*
	int r, R, n;
	cin >> r >> R >> n;
	double pi = acos(-1);
	cout.precision(20);
	if (n < 4)
	{
		if (n % 2 == 0)
		{
			double ans = (pi * (R - r) / 2 + pi * (R + r) / n + 2 * pi * r / n) * n / 2;
			cout << ans << endl;
		}
		else
		{
			double ans = (pi * (R - r) / 2 + pi * (R + r) / n + 2 * pi * r / n) * (n - 1) / 2 + pi * (R - r) / 4 + pi * (R + r) / n;
			cout << ans << endl;
		}
	}
	else
	{
		double ans = pi * ((R - r) / 2 + (R + r) / n) * n;
		cout << ans << endl;
	}
	return 0;
	*/
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		int ind = abs(b) - 1;
		if (b < 0) chelik[a].push_back(ind * 2 + 0);
		else chelik[a].push_back(ind * 2 + 1);
	}
	int sz = 2 * m;
	for (int i = 0; i < n; i++)
	{
		vector <int> pref, suf;
		for (int x : chelik[i])
		{
			pref.push_back(sz++);
			suf.push_back(sz++);
		}
		auto &p = chelik[i];
		for (int i = 0; i < (int) pref.size(); i++)
		{
			if (i)
				add_edge(pref[i], pref[i - 1]);
			add_edge(pref[i], p[i]);
		}
		for (int i = (int) suf.size() - 1; i >= 0; i--)
		{
			if (i != (int) suf.size() - 1)
			{
				add_edge(suf[i], suf[i + 1]);
			}
			add_edge(suf[i], p[i]);
		}
		for (int i = 0; i < (int) p.size(); i++)
		{
			int v = (p[i] ^ 1);
			if (i != 0)
			{
				add_edge(v, pref[i - 1]);
			}
			if (i != (int) p.size() - 1)
			{
				add_edge(v, suf[i + 1]);
			}
		}
	}
	for (int i = 0; i < sz; i++)
	{
		if (!u[i])
		{
			dfs(i);
		}
	}
	reverse(t.begin(), t.end());
	for (int v : t) u[v] = 0;
	for (int v : t)
	{
		if (!u[v])
		{
			zhfs(v);
			ind++;
		}
	}
	vector <int> e;
	for (int i = 0; i < m; i++)
	{
		if (comp[2 * i + 0] == comp[2 * i + 1])
		{
			cout << -1 << '\n';
			return 0;
		}
		if (comp[2 * i + 0] < comp[2 * i + 1]) e.push_back(i);
	}
	cout << e.size() << '\n';
	for (int i : e)
	{
		cout << i + 1 << ' ';
	}
	cout << '\n';
}
