#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2007;
long long dp[MAX_N][MAX_N];
const long long INF = 1e18;
long long t[MAX_N + 1], p[MAX_N + 1];


int main() {
    int n, tt;
    cin >> n >> tt;
    pair <long long, long long> tp[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> tp[i].first >> tp[i].second;
    }
    sort(tp + 1, tp + n + 1, greater <pair <long long, long long>>());
    dp[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        t[i] = tp[i].first;
        p[i] = tp[i].second;
    }
    for (int i = 1; i <= tt; i++) dp[0][i] = INF;
    for (int i = 1; i <= n; i++) {
        dp[i][0] = 0;
        for (int j = 1; j <= tt; j++) {
            dp[i][j] = dp[i - 1][j];
            if (j - t[i] >= 0 && dp[i - 1][j - t[i]] + p[i] < dp[i][j]) dp[i][j] = dp[i - 1][j - t[i]] + p[i];
        }
    }
    long long ans = INF;
    for (int t0 = tt; t0 >= 0; t0--) {
        long long s = 0, ans_c = 0;
        int j;
        for (j = n; j >= 1; j--) {
            if (t[j] <= (tt - t0)) {
                s += t[j];
                ans_c += p[j];
            } else {
                break;
            }
        }
        //cout << t0 << ' ' << s << endl;
        if (t0 - s < 0) continue;
        ans = min(ans, ans_c + dp[j][t0 - s]);
    }
    cout << ans << endl;
    return 0;
}
