///**************************************************************
//* Copyright (C) 2018 Computer Graphics Support Group
//*   of Phys-Math Lyceum No. 30
//**************************************************************/
///*************************************************************
// * NAME		   : Source.cpp
// * PURPOSE     : Pomoyka
// * PROGRAMMER  : SS5, OM5, DT6
// * LAST UPDATE : 28.10.2018
// * No part of this file can be changed without agreement of Com
// *************************************************************/
//
//
//#include <iostream>
//using namespace std;
//#include <cmath>
//#include <cstdio>
//#include <map>
//#include <string>
//#include <algorithm>
//#include <vector>
//
//#define PI 3.141592653589793L
//
//struct city
//{
//	long num, d;
//};
//
//bool Eq(const city &C1, const city &C2)
//{
//	return C1.d > C2.d;
//}
//
///* Main function/
// * ARGUMENTS: None.
// * RETURNS:
// *   (int) Program exit code (0 if success).
// */
//int main()
//{
//	vector<city> Citys;
//	long n;
//
//	cin >> n;
//
//	for (int i = 0; i < n; i++)
//	{	
//		city ct = city();
//		cin >> ct.d;
//		ct.num = i + 1;
//		Citys.push_back(ct);
//	}
//
//	sort(Citys.begin(), Citys.end(), Eq);
//
//	for (int i = 0; i < n; i++)
//	{
//		if (Citys[i].d != 0)
//		{
//			long add = 0;
//			for (int j = 0; j < Citys[i].d + add - !!i; j++)
//				if (Citys[j + i + 1].d != Citys[i].d)
//					cout << Citys[i].num << ' ' << Citys[j + i + 1].num << '\n';
//				else
//					add++;
//		}
//	}
//	
//	return 0;
//} /* End of 'main' function */
//
///* END OF 'Source.cpp' FILE */

/**************************************************************
* Copyright (C) 2018 Computer Graphics Support Group
*   of Phys-Math Lyceum No. 30
**************************************************************/
/*************************************************************
* NAME        : Source.cpp
* PURPOSE     : Pomoyka
* PROGRAMMER  : SS5, OM5, DT6
* LAST UPDATE : 28.10.2018
* No part of this file can be changed without agreement of Com
*************************************************************/


#include <iostream>
#include <string>
using namespace std;



#define ll __int128 

/* Main function/
* ARGUMENTS: None.
* RETURNS:
*   (int) Program exit code (0 if success).
*/
int main()
{
	unsigned long long n, m, h, w;

	cin >> n;
	cin >> m;
	cin >> h;
	cin >> w;

	unsigned long long c1 = 0, c2 = 0;

	unsigned long long n1 = n, m1 = m, h1 = h, w1 = w;

	bool is_1div2 = 0;
	while (n1 > h1)
	{
		c1++;
		if (is_1div2 && (n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else if (is_1div2 && !(n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else
		{
			is_1div2 = n1 & 1;
			n1 = n1 / 2 + is_1div2;
		}
	}
	n1 = m1;
	is_1div2 = 0;
	while (n1 > w1)
	{
		c1++;
		if (is_1div2 && (n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else if (is_1div2 && !(n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else
		{
			is_1div2 = n1 & 1;
			n1 = n1 / 2 + is_1div2;
		}
	}

	is_1div2 = 0;
	n1 = n;
	m1 = m;
	while (n1 > w1)
	{
		c2++;
		if (is_1div2 && (n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else if (is_1div2 && !(n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else
		{
			is_1div2 = n1 & 1;
			n1 = n1 / 2 + is_1div2;
		}
	}
	n1 = m1;
	is_1div2 = 0;
	while (n1 > h1)
	{
		c2++;
		if (is_1div2 && (n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else if (is_1div2 && !(n1 & 1))
		{
			is_1div2 = 0;
			n1 /= 2;
		}
		else
		{
			is_1div2 = n1 & 1;
			n1 = n1 / 2 + is_1div2;
		}
	}

	if (c2 < c1)
		cout << c2;
	else
		cout << c1;
	return 0;
} /* End of 'main' function */

  /* END OF 'Source.cpp' FILE */