import math

magic = 10**18
def fold_side_amount(letter, box):
	lg = math.log2(letter*magic) - math.log2(box*magic)
	m = math.ceil(lg)
	assert(lg <= m)
	while lg <= (m - 1): m -= 1
	return m	

# n, m -- letter; h, w -- box
def _find_fold_amount(n, m, h, w):
	l = fold_side_amount(n, h)
	r = fold_side_amount(m, w)
	return l + r

# correct
def find_fold_amount(n, m, h, w):
	a = _find_fold_amount(n, m, h, w)
	b = _find_fold_amount(m, n, h, w)
	return min(a, b)

inp = input().split()
n = int(inp[0])
m = int(inp[1])
h = int(inp[2])
w = int(inp[3])
print(find_fold_amount(n, m, h, w))