#include <cstdio>
#include <iostream>

long long min(long long a, long long b)
{
	if (a <= b)
		return a;
	return b;
}

long long max(long long a, long long b)
{
	if (a >= b)
		return a;
	return b;
}

void Swap(long double *a, long double *b)
{
	long double tmp = *a;
	*a = *b;
	*b = tmp;
}
int main(void)
{
	long long n, m, h, w;
	long double mina, minb, maxa, maxb;
	int count = 0;

	scanf("%lld %lld %lld %lld", &n, &m, &h, &w);
	mina = min(n, m);
	minb = min(h, w);
	maxa = max(n, m);
	maxb = max(h, w);
	while (maxa > maxb)
	{
		count++;
		maxa /= 2;
		if (maxa < mina)
			Swap(&maxa, &mina);
	}
	while (mina > minb)
	{
		count++;
		maxa /= 2;
	}
	std::cout << count;
	return 0;
}