#include <iostream>
#include <cmath>

using namespace std;

void Swap(unsigned __int64 &a, unsigned __int64 &b)
{
  unsigned __int64 tmp = a;
  a = b, b = tmp;
}

int main(void)
{
  unsigned __int64 n, m, h, w, S1 = 0, S2 = 0;

  cin >> n >> m >> h >> w;

  if (h > w)
    Swap(h, w);

  if (n > m)
    Swap(n, m);

  unsigned __int64 n1 = n, m1 = m;

  while (m1 > w)
  {
    m1 = m1 % 2 == 0 ? m1 / 2 : m1 / 2 + 1;
    S1++;
  }

  while (n1 > h)
  {
    n1 = n1 % 2 == 0 ? n1 / 2 : n1 / 2 + 1;
    S1++;
  }

  /* second type iterations */
  while (m > h)
  {
    m = m % 2 == 0 ? m / 2 : m / 2 + 1;
    S2++;
  }

  while (n > w)
  {
    n = n % 2 == 0 ? n / 2 : n / 2 + 1;
    S2++;
  }

  if (S1 > S2)
    cout << S2;
  else
    cout << S1;

  return 0;
}