import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class nD {
	class Point implements Comparable<Point> {
		int x;
		int weight;

		public Point(int x, int weight) {
			super();
			this.x = x;
			this.weight = weight;
		}

		@Override
		public int compareTo(Point o) {
			if (weight != o.weight) {
				return -(weight - o.weight);
			}
			return x - o.x;
		}

	}

	public void run() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		pw = new PrintWriter(System.out);
		int n = nextInt();
		Point[] arr = new Point[n];
		for(int i = 0; i < n; i++) {
			int x = nextInt();
			arr[i] = new Point(i, x);
		}
		Arrays.sort(arr);
		int max = 0;
		int p = 1;
		while(p < n) {
			pw.println((arr[max].x + 1) +" " + (arr[p].x + 1));
			arr[max].weight--;
			while(arr[max].weight <= 0) {
				max++;
			}
			arr[p].weight--;
			p++;
		}
		pw.close();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter pw;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new nD().run();
	}

}