
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef ONPC
	mt19937 rnd(228);
#else
	mt19937 rnd(time(0));
#endif

int f[5][15][5][15];

const int M = 998244353;

inline int add(int a, int b)
{
	a += b;
	if (a < 0) a += M;
	if (a >= M) a -= M;
	return a;
}

inline int mul(int a, int b)
{
	return (a * (ll) b) % M;
}

const int inf = 1e9;

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			for (int x = 0; x < n; x++)
			{
				for (int y = 0; y < m; y++)
				{
					f[i][j][x][y] = -1;
				}
			}
		}
	}
	for (int i = 0; i < k; i++)
	{
		int r1, c1, r2, c2, w;
		cin >> r1 >> c1 >> r2 >> c2 >> w;
		r1--, c1--, r2--, c2--;
		f[r1][c1][r2][c2] = f[r2][c2][r1][c1] = w;
	}
	map <vector <int>, int> dp;
	vector <int> arr(n, inf);
	arr[m - 1] = 0;
	dp[arr] = 1;
	int ans = 0;
	for (int j = m - 1; j >= 0; j--)
	{
		map <vector <int>, int> ndp;
		for (auto c : dp)
		{
			int can_left = (1 << n);
			int can_up = (1 << (n - 1));
			if (j == 0) can_left = 1;
			for (int mask_left = 0; mask_left < can_left; mask_left++)
			{
				for (int mask_up = 0; mask_up < can_up; mask_up++)
				{
					vector <int> d(n, inf);
					vector <int> cur = c.first;
					bool bad = false;
					for (int i = n - 2; i >= 0; i--)
					{
						if ((mask_up >> i) & 1)
						{
							if (f[i][j][i + 1][j] == 1) bad = true;
							cur[i] = min(cur[i], cur[i + 1] + 0);
						}
						else
						{
							if (f[i][j][i + 1][j] == 0) bad = true;
							cur[i] = min(cur[i], cur[i + 1] + 1);
						}
					}
					if (j != 0)
					for (int i = 0; i < n; i++)
					{
						if ((mask_left >> i) & 1)
						{
							if (f[i][j][i][j - 1] == 1) bad = true;
							d[i] = min(d[i], cur[i] + 0);
						}
						else
						{
							if (f[i][j][i][j - 1] == 0) bad = true;
							d[i] = min(d[i], cur[i] + 1);
						}
					}
					if (!bad)
					{
						ndp[d] = add(ndp[d], c.second);
						if (j == 0)
						{
							if (*min_element(cur.begin(), cur.end()) == *max_element(cur.begin(), cur.end()))
							{
								ans = add(ans, c.second);
							}
						}
					}
				}
			}
		}
		dp = ndp;
	}
	cout << ans << '\n';
}
