/**************************************************************
* Copyright (C) 2018 Computer Graphics Support Group
*   of Phys-Math Lyceum No. 30
**************************************************************/
/*************************************************************
 * NAME		   : Source.cpp
 * PURPOSE     : Pomoyka
 * PROGRAMMER  : SS5, OM5, DT6
 * LAST UPDATE : 28.10.2018
 * No part of this file can be changed without agreement of Com
 *************************************************************/


#include <iostream>
using namespace std;
#include <cmath>
#include <cstdio>

#define PI 3.141592653589793L

/* Main function/
 * ARGUMENTS: None.
 * RETURNS:
 *   (int) Program exit code (0 if success).
 */
int main()
{
	long long r, R, n;

	cin >> r >> R >> n;

	long double Summ1 = PI * r * n / 2.0, Summ2 = PI * r * (n - 1);

	if (n & 1)
		Summ1 += (n / 2) * (2 * PI * (R - r) + 2 * PI * R) / n;
	else
		Summ1 += (n / 2) * 2 * PI * (R - r) / n + (n / 2 - 1) * 2 * PI * R / n;

	Summ2 += 2 * PI * (R - r) * (1.0 - 1.0 / n);

	if (Summ1 > Summ2 && n > 1)
		printf("%.20lf", Summ2);
	else
		printf("%.20lf", Summ1);

	return 0;
} /* End of 'main' function */

/* END OF 'Source.cpp' FILE */