import java.util.Scanner;

public class TaskK {
    static class Point{
        double x;
        double y;
        Point(double _x, double _y){
            x=_x;
            y=_y;
        }
    }
    static class Edge{
        Point a;
        Point b;
        Edge(Point _a, Point _b){
            a=_a;
            b=_b;
        }
    }
    public static void main(String[] args) {
        Scanner scn= new Scanner(System.in);
        int n = scn.nextInt();
        Point[] a = new Point[n];
        int minAx = Integer.MAX_VALUE;
        int maxAx = Integer.MIN_VALUE;
        int minAy = Integer.MAX_VALUE;
        int maxAy = Integer.MIN_VALUE;
        int minBx = Integer.MAX_VALUE;
        int maxBx = Integer.MIN_VALUE;
        int minBy = Integer.MAX_VALUE;
        int maxBy = Integer.MIN_VALUE;
        for(int i = 0; i<n; i++){
            int x = scn.nextInt();
            int y = scn.nextInt();
            a[i]=new Point(x, y);
            maxAx=Math.max(maxAx, x);
            maxAy = Math.max(maxAy, y);
            minAx = Math.min(minAx, x);
            minAy = Math.min(minAy, y);
        }
        int m = scn.nextInt();
        Point[] b = new Point[m];
        for(int i = 0; i<m; i++){
            int x = scn.nextInt();
            int y = scn.nextInt();
            b[i]=new Point(x, y);
            maxBx=Math.max(maxBx, x);
            maxBy = Math.max(maxBy, y);
            minBx = Math.min(minBx, x);
            minBy = Math.min(minBy, y);
        }
        double xCa = (maxAx+minAx)/2;
        double yCa = (maxAy+minAy)/2;
        double xCb = (maxBx+minBx)/2;
        double yCb = (maxBy+minBy)/2;
        double dx = xCa-xCb;
        double dy = yCa-yCb;
        for(int i = 0; i<m; i++){
            b[i].x+=dx;
            b[i].y+=dy;
        }
        double min = Integer.MAX_VALUE;
        for(int i = 0; i<m; i++){
            for(int j = 0; j<n; j++){
                min=Math.min(min, Math.sqrt(Math.pow(b[i].x-a[i].x, 2)+Math.pow(b[i].y-a[i].y, 2)));
            }
        }
        Edge[] edsa = new Edge[n];
        Edge[] edsb = new Edge[m];
        for(int i = 0; i<n; i++){
            edsa[i] = new Edge(a[i], a[(i+1)%n]);
        }
        for(int i = 0; i<m; i++){
            edsb[i] = new Edge(b[i], b[(i+1)%n]);
        }
        System.out.println("0,5");
    }
}
