import sys

def next0(c, cut=True):
    if(c[9] > 0):
        c[9]-=cut
        return "9"
    if(c[6] > 0):
        c[6] -=cut
        return "6"
    if(c[3] > 0):
        c[3]-=cut
        return "3"
    if(c[0] > 0):
        c[0] -=cut
        return "0"
    return -1
def next1(c, cut=True):
    if(c[7] > 0):
        c[7] -=cut
        return "7"
    if(c[4] > 0):
        c[4] -=cut
        return "4"
    if(c[1] > 0):
        c[1]-=cut
        return "1"
    return -1
def next2(c, cut=True):
    if(c[8] > 0):
        c[8]-=cut
        return "8"
    if(c[5] > 0):
        c[5] -=cut
        return "5"
    if(c[2] > 0):
        c[2]-=cut
        return "2"
    return -1

def next(c, numnext, cut=True):
    if numnext == 0:
        return next0(c, cut)
    if numnext == 1:
        return next1(c, cut)
    if numnext == 2:
        return next2(c, cut)
    return -1



def findans(first, second, third, c):
    ans = "0"
    while next(c, first, cut=False) != -1 and next(c, second, cut=False) != -1 and next(c, third, cut=False) != -1:
        ans += next(c, first)
        if next(c, second, cut=False) != -1:
            ans += next(c, second)
            if next(c, third, cut=False) != -1:
                ans += next(c, third)
    if next(c, first, cut=False) != -1:
        ans += next(c, first)
        if next(c, second, cut=False) != -1:
            ans += next(c, second)
    return int(ans)

def main():
    c = list(map(int, sys.stdin.readline().split()))
    ans = [   findans(0, 1, 2, c.copy()),
              findans(0, 2, 1, c.copy()),
              findans(1, 0, 2, c.copy()),
              findans(1, 2, 0, c.copy()),
              findans(2, 0, 1, c.copy()),
              findans(2, 1, 0, c.copy()),
              findans(0, 0, 0, c.copy()),
              findans(1, 1, 1, c.copy()),
              findans(2, 2, 2, c.copy())]
    sys.stdout.write(str(max(ans)))
main()