#include<stdio.h>
#include<math.h>
#include<cmath>

const long double magic = pow(10, 18);

int fold_side_amount(long double letter, long double box) {
	int i = 0;
	while (letter > box) {
		letter = letter / 2;
		i += 1;
	}
	return i;
}

int _fold_amount(long double n, long double m, long double h, long double w) {
	return fold_side_amount(n, h) + fold_side_amount(m, w);
}

int fold_amount(long double n, long double m, long double h, long double w) {
	int a = _fold_amount(n, m, h, w);
	int b = _fold_amount(m, n, h, w);
	if (a <= b) { return a; }
	else { return b; }
}

int main(void) {
	int _n = 0;
	int _m = 0;
	int _h = 0;
	int _w = 0;
	scanf("%d %d %d %d", &_n, &_m, &_h, &_w);
	double n = (long double)_n;
	double m = (long double)_m;
	double h = (long double)_h;
	double w = (long double)_w;
	int answer = fold_amount(n, m, h, w);
	printf("%d\n", answer);
}