import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class G {
    String fileName = "<name>";

    public void solve() throws IOException {
        int n = nextInt();
        if (n % 2 == 1) {
            if (n < 5) {
                out.println("NO");
                return;
            }
            out.println("YES");
            out.println(2);
            out.print("++---");
            for (int i = 0; i < n - 5; i++) {
                if (i % 2 == 0) {
                    out.print('+');
                } else {
                    out.print('-');
                }
            }
            return;
        }
        out.println("YES");
        out.println(1);
        for (int i = 0; i < n; i++) {
            if (i % 2 == 0) {
                out.print('+');
            } else {
                out.print('-');
            }
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G().run();
    }

}
