#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

#define vi vector<int>
#define pb push_back
using namespace std;

int main() {
    int n;
    cin >> n;
    bool a[2002][2002];
    bool used[2002][2002];
    for (int i = 0; i < 2002; ++i) {
        for (int j = 0; j < 2002; ++j) {
            a[i][j] = used[i][j] = 0;
        }
    }
    int x0 = 1e9;
    int y0 = 1e9;
    int x1 = -1e9;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[2 * x][2 * y] = 1;
        a[2 * x + 1][2 * y] = 1;
        a[2 * x][2 * y + 1] = 1;
        a[2 * x + 1][2 * y + 1] = 1;
        if (x < x0) {
            x0 = x;
            y0 -= y;
        }
        if (x > x1) {
            x1 = x;
        }
        if (x == x0 && y < y0) {
            x0 = x;
            y0 = y;
        }
    }
    bool b = true;
    int x = x0;
    int y = y0;
    vector<pair<int, int>> ans;
    ans.pb({x, y});
    while (true) {
        used[x][y] = 1;
        if (x == x1) b = false;
        if (b) {
            if (a[x - 1][y] && !used[x - 1][y]) {
                x--;
                ans.pb({x - 1, y});
            } else if (a[x][y - 1] && !used[x - 1][y]) {
                y--;
                ans.pb({x, y - 1});
            } else if (a[x + 1][y] && !used[x + 1][y]) {
                x++;
                ans.pb({x + 1, y});
            } else {
                y++;
                ans.pb({x, y + 1});
            }
        } else {
            if (a[x][y + 1] && !used[x][y + 1]) {
                y++;
                ans.pb({x, y + 1});
            } else if (a[x - 1][y]) {
                x--;
                ans.pb({x - 1, y});
            } else if (a[x][y - 1] && !used[x][y - 1]) {
                y--;
                ans.pb({x, y - 1});
            } else {
                x++;
                ans.pb({x + 1, y});
            }
        }
        if (x == x0 && y == y0) break;
    }
    for (int i = 0; i < ans.size() - 1; ++i) cout << ans[i].first << " " << ans[i].second << endl;
    return 0;
}